
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Did you call them autocrap tools ? &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Why Sphinx and reStructuredText ?" href="sphinx.html" />
    <link rel="prev" title="What were they thinking ?" href="thoughts.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="sphinx.html" title="Why Sphinx and reStructuredText ?"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="thoughts.html" title="What were they thinking ?"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Did you call them <em>autocrap</em> tools ?</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="did-you-call-them-autocrap-tools">
<span id="phk-autocrap"></span><h1>Did you call them <em>autocrap</em> tools ?<a class="headerlink" href="#did-you-call-them-autocrap-tools" title="Permalink to this headline">¶</a></h1>
<p>Yes, in fact I did, because they are the worst possible non-solution
to a self-inflicted problem.</p>
<p>Back in the 1980’ies, the numerous mini- and micro-computer companies
all jumped on the UNIX band-wagon, because it gave them an operating
system for their hardware, but they also tried to “distinguish” themselves
from the competitors, by “adding value”.</p>
<p>That “value” was incompatibility.</p>
<p>You never knew where they put stuff, what arguments the compiler needed
to behave sensibly, or for that matter, if there were a compiler to begin
with.</p>
<p>So some deranged imagination, came up with the idea of the <code class="docutils literal notranslate"><span class="pre">configure</span></code>
script, which sniffed at your system and set up a <code class="docutils literal notranslate"><span class="pre">Makefile</span></code> that would
work.</p>
<p>Writing configure scripts was hard work, for one thing you needed a ton
of different systems to test them on, so copy&amp;paste became the order of
the day.</p>
<p>Then some even more deranged imagination, came up with the idea of
writing a script for writing configure scripts, and in an amazing
and daring attempt at the “all time most deranged” crown, used an
obscure and insufferable macro-processor called <code class="docutils literal notranslate"><span class="pre">m4</span></code> for the
implementation.</p>
<p>Now, as it transpires, writing the specification for the configure
producing macros was tedious, so somebody wrote a tool to…</p>
<p>…do you detect the pattern here ?</p>
<p>Now, if the result of all this crap, was that I could write my source-code
and tell a tool where the files were, and not only assume, but actually
<em>trust</em> that things would just work out, then I could live with it.</p>
<p>But as it transpires, that is not the case.  For one thing, all the
autocrap tools add another layer of version-madness you need to get
right before you can even think about compiling the source code.</p>
<p>Second, it doesn’t actually work, you still have to do the hard work
and figure out the right way to explain to the autocrap tools what
you are trying to do and how to do it, only you have to do so in
a language which is used to produce M4 macro invocations etc. etc.</p>
<p>In the meantime, the UNIX diversity has shrunk from 50+ significantly
different dialects to just a handful: Linux, *BSD, Solaris and AIX
and the autocrap tools have become part of the portability problem,
rather than part of the solution.</p>
<p>Amongst the silly activities of the autocrap generated configure script
in Varnish are:</p>
<ul class="simple">
<li><p>Looks for ANSI-C header files (show me a system later
than 1995 without them ?)</p></li>
<li><p>Existence and support for POSIX mandated symlinks, (which
are not used by Varnish btw.)</p></li>
<li><p>Tests, 19 different ways, that the compiler is not a relic from
SYS III days.  (Find me just one SYS III running computer with
an ethernet interface ?)</p></li>
<li><p>Checks if the ISO-C and POSIX mandated <code class="docutils literal notranslate"><span class="pre">cos()</span></code> function exists
in <code class="docutils literal notranslate"><span class="pre">libm</span></code> (No, I have no idea either…)</p></li>
</ul>
<p>&amp;c. &amp;c. &amp;c.</p>
<p>Some day when I have the time, I will rip out all the autocrap stuff
and replace it with a 5 line shellscript that calls <code class="docutils literal notranslate"><span class="pre">uname</span> <span class="pre">-s</span></code>.</p>
<p>Poul-Henning, 2010-04-20</p>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="thoughts.html"
                        title="previous chapter">What were they thinking ?</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="sphinx.html"
                        title="next chapter">Why Sphinx and reStructuredText ?</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/autocrap.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="sphinx.html" title="Why Sphinx and reStructuredText ?"
             >next</a> |</li>
        <li class="right" >
          <a href="thoughts.html" title="What were they thinking ?"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Did you call them <em>autocrap</em> tools ?</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>